--[[ 
	ChatBuddy
	author: Rhianidd
--]]

local AddonName, CB = ...
local SavedChatBuddyHandler = ChatFrame_OpenChat

local ChatBuddyFrame = CreateFrame("Frame")
ChatBuddyFrame:RegisterEvent("VARIABLES_LOADED")
ChatBuddyFrame:SetScript("OnEvent", function(frame, event, ...) frame[event](frame, ...) end) -- passes with 'this'/small-self as 1st para
function ChatBuddyFrame:VARIABLES_LOADED()
	if not ChatBuddyDB then -- Saved Vars & Defaults
		ChatBuddyDB = {
			["enabled"] = true,
			["DefaultChan"] = "s",			-- set 's' to default, will reset 'g' if in a guild 10sec delay to account for various load-times among users and the lazy-load in GetGuildInfo()
			["DefaultChanBackup"] = "s" -- say
		}		
   	C_Timer.After(10, function() ChatBuddyDB.DefaultChan = GetGuildInfo("player") and "g" or "s" end)
 	end

	-- Recepricate for ChatFrame_OpenChat
	ChatFrame_OpenChat = CB.func_OpenChat
end


local attributeTable = {
	["g"] = "GUILD",
	["p"] = "PARTY",
	["r"] = "RAID",
	["o"] = "OFFICER",
	["s"] = "SAY",
	["i"] = "INSTANCE_CHAT",
	["1"] = "CHANNEL",
	["2"] = "CHANNEL",
	["3"] = "CHANNEL",
	["4"] = "CHANNEL",
	["5"] = "CHANNEL",
	["6"] = "CHANNEL",
	["7"] = "CHANNEL",
	["8"] = "CHANNEL",
	["9"] = "CHANNEL",
}
function CB.func_OpenChat(text)
	chatFrame = DEFAULT_CHAT_FRAME
	local editBox = DEFAULT_CHAT_FRAME.editBox
	local chatType = editBox.chatType
	
	if ChatBuddyDB.enabled then 																			-- Need to check strings vs numbers
		local stickyType = attributeTable[ ChatBuddyDB.DefaultChan ]
		local chanCheck = tonumber( ChatBuddyDB.DefaultChan )

		if stickyType then
			editBox:SetAttribute("stickyType", stickyType)
			if chanCheck then
				editBox:SetAttribute("channelTarget", stickyType)
			end
		end
	else
		if (chatType) then
			if ( ChatTypeInfo[chatType].sticky == 1 ) then
				editBox:SetAttribute("stickyType", chatType)
			end
		else
			editBox:SetAttribute("stickyType", "SAY")
		end	
	end
	
	SavedChatBuddyHandler(text)
end

function ChatBuddy_OpenChat(text, chatFrame)
	chatFrame = DEFAULT_CHAT_FRAME
	box = chatFrame.editBox

	if ChatBuddyDB.enabled then
		if ( ( ((box:GetAttribute("stickyType") == "PARTY") or (box:GetAttribute("stickyType") == "INSTANCE")) and (GetNumGroupMembers() == 0) 
				and (ChatBuddyDefaultChannel == "p") ) or
			( (box:GetAttribute("stickyType") == "RAID") and (GetNumGroupMembers() == 0) 
				and (ChatBuddyDefaultChannel == "r" or ChatBuddyDefaultChannel == "raid") )) then
			if ((box:GetAttribute("chatType") and box:GetAttribute("chatType") ~= "WHISPER") and (box:GetAttribute("chatType") ~= "BN_WHISPER")) then
				box:SetAttribute("chatType", "SAY")
			end
		end

		ChatBuddy_SetSticky(box)

		if (box:GetAttribute("chatType")) then
			if ((box:GetAttribute("chatType") ~= "WHISPER") and (box:GetAttribute("chatType") ~= "BN_WHISPER")) then
				box:SetAttribute("chatType", box:GetAttribute("stickyType"))
			else -- whisper
				box.text = ""
				box.setText = 1
			end
		end
	end
	
	SavedChatBuddyHandler(text, chatFrame)
end

function ChatBuddy_SetSticky(editBox)
	local type = editBox.chatType
	local def = ChatBuddyDB.DefaultChan

	if (ChatBuddyDB.enabled == 1) then
		if (def == "z") then
			-- last channel
			editBox:SetAttribute("stickyType", type)
		else 
			ChatTypeInfo["WHISPER"].sticky = 0
			ChatTypeInfo["BN_WHISPER"].sticky = 0 -- battle tag
			-- specific channel
			if ( def == "g") then
				editBox:SetAttribute("stickyType", "GUILD")
			elseif (def == "p") then
				editBox:SetAttribute("stickyType", "PARTY")
			elseif (def == "r" or def == "raid") then
				editBox:SetAttribute("stickyType", "RAID")
			elseif (def == "o") then
				editBox:SetAttribute("stickyType", "OFFICER")
			elseif (def == "s") then
				editBox:SetAttribute("stickyType", "SAY")
			elseif (def == "i") then
				editBox:SetAttribute("stickyType", "INSTANCE_CHAT")
			elseif ((def >= "0") and (def <= "9")) then
				editBox:SetAttribute("stickyType", "CHANNEL")
				editBox:SetAttribute("channelTarget", def)
			else 
				-- regular method
				--ChatBuddy_ChatMsg("sticky " .. ChatTypeInfo[type].sticky .. "type " .. type)
				if ( ChatTypeInfo[type].sticky == 1 and ((type ~= "WHISPER") and (type ~= "BN_WHISPER"))) then
					editBox:SetAttribute("stickyType", type)
				end
			end
		end
	else
		-- this is the usual chat method
		if (type) then
			if ( ChatTypeInfo[type].sticky == 1 ) then
				editBox:SetAttribute("stickyType", type)
			end
		else
			editBox:SetAttribute("stickyType", "SAY")
		end
	end
end


function CB:SlashHandler(msg)
	msg = string.lower(msg)

	local _, pos, command, defchat = string.find(msg, "(%w+)")
	-- respond to command
    if (command == nil) then
        ChatBuddy_DisplayUseage()
    elseif (command == "enable") then
			ChatBuddyDB.enabled = true
			ChatBuddy_ChatMsg("Chat Buddy Enabled")
    elseif (command == "disable") then
			ChatBuddyDB.enabled = false
			ChatBuddy_ChatMsg("Chat Buddy Disabled")
    elseif (command == "status") then
    	ChatBuddy_DisplayStatus()
    elseif (command == "set") then
    	local newchan = select(3, string.find(msg, "(%w+)", pos+1))
        if (newchan == nil) then
           	ChatBuddy_DisplayUseage()
        else
            ChatBuddyDB.DefaultChan = newchan
            ChatBuddy_DisplayStatus()
        end
    else
        ChatBuddy_DisplayUseage()
    end
end

function ChatBuddy_DisplayStatus()
	local text = "|cffff9966Chat Buddy|r"
   if ChatBuddyDB.enabled then
   	text = text .. " is |cff00ff00On|r --"
      if ChatBuddyDB.DefaultChan == "z" then
      	text = text .. " Using the last channel as default"
      else
      	text = text .. " Using /" .. ChatBuddyDB.DefaultChan .. " as default"
      end
   else
   	text = text .. " is |cffff0000Off|r"
   end
   ChatBuddy_ChatMsg(text)
end

function ChatBuddy_DisplayUseage()
	local text = "Useage: \n/ChatBuddy <Enable | Disable | Status>\n"
   text = text .. "/ChatBuddy set <channelcode>  (i.e. g for /g, p for /p, r for /raid, b for /bg, z for last channel)"

	ChatBuddy_DisplayStatus()
  ChatBuddy_ChatMsg(text)
end

function ChatBuddy_ChatMsg(msg)
	if( ChatFrame1 ) then
		ChatFrame1:AddMessage(msg)
	end
end

-- Register command handler and new commands
SLASH_CB1 = "/ChatBuddy"
SLASH_CB2 = "/cb"
SlashCmdList["CB"] = function(msg)
	CB:SlashHandler(msg)
end
